/**
* DevExtreme (ui/slide_out_view.d.ts)
* Version: 21.1.0 (build 21016-0316)
* Build date: Sat Jan 16 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import '../jquery_augmentation';

import {
    dxElement
} from '../core/element';

import {
    template
} from '../core/templates/template';

import Widget, {
    WidgetOptions
} from './widget/ui.widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxSlideOutViewOptions extends WidgetOptions<dxSlideOutView> {
    /**
     */
    contentTemplate?: template | ((contentElement: dxElement) => any);
    /**
     */
    menuPosition?: 'inverted' | 'normal';
    /**
     */
    menuTemplate?: template | ((menuElement: dxElement) => any);
    /**
     */
    menuVisible?: boolean;
    /**
     */
    swipeEnabled?: boolean;
}
/**
 */
export default class dxSlideOutView extends Widget {
    constructor(element: Element, options?: dxSlideOutViewOptions)
    constructor(element: JQuery, options?: dxSlideOutViewOptions)
    /**
     */
    content(): dxElement;
    /**
     */
    hideMenu(): Promise<void> & JQueryPromise<void>;
    /**
     */
    menuContent(): dxElement;
    /**
     */
    showMenu(): Promise<void> & JQueryPromise<void>;
    /**
     */
    toggleMenuVisibility(): Promise<void> & JQueryPromise<void>;
}

declare global {
interface JQuery {
    dxSlideOutView(): JQuery;
    dxSlideOutView(options: "instance"): dxSlideOutView;
    dxSlideOutView(options: string): any;
    dxSlideOutView(options: string, ...params: any[]): any;
    dxSlideOutView(options: dxSlideOutViewOptions): JQuery;
}
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxSlideOutViewOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxSlideOutViewOptions;
